#!/usr/bin/env python
"""
Simple functions for experimenting with the Collatz sequence.

>>> collatz(5)
[5, 16, 8, 4, 2, 1]
"""

def collatz(n):
    # base case: we're done if n is 1
    if n == 1:
        return [1]

    # otherwise, we need to find the next element in the sequence.
    #   - if n is even, it's n/2
    #   - if n is odd, it's 3n+1
    if n%2 == 0:
        next_entry = n/2
    else:
        next_entry = 3*n+1

    return [n] + collatz(next_entry)

if __name__ == '__main__':
    import sys
    if len(sys.argv) != 2:
        print "Incorrect number of arguments (expected 2, got %s)."%len(sys.argv)
        exit(1)

    ls = collatz(int(sys.argv[1]))
    print "Sequence reached 1 after %s steps."%(len(ls)-1)
    print " Entries:", ls

def short_collatz(n):
    import math
    return (n == 1 and [1]) or \
           ([n] + short_collatz(int(abs(math.sin(math.pi*n/2)))*(3*n+1) +
                                int(abs(math.cos(math.pi*n/2)))*(n/2)))

